import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'admin' },
})
export class Admin extends BaseModel {
  @prop({ required: false, index: false, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({
    required: false,
    index: false,
    zh: '系统使用名',
    default: '系统管理员',
  })
  name: string;
}
