import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import File from 'free-midway-component/dist/entity/fileType';
@modelOptions({
  schemaOptions: { collection: 'article' },
})
export class Article extends BaseModel {
  @prop({ required: false, index: false, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '医生', ref: 'Doctor' })
  doctor: string;
  @prop({ required: false, index: false, zh: '来源' })
  origin: string;
  @prop({
    required: false,
    index: false,
    zh: '图片',
    remark: '这个不是文件,就是字符串地址',
  })
  img_url: File;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
  @prop({ required: false, index: true, zh: '发布时间' })
  create_time: string;
  @prop({ required: false, index: true, zh: '是否使用', default: '0' })
  is_use: string;
}
