import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'chat' },
})
export class Chat extends BaseModel {
  @prop({ required: false, index: true, zh: '发送人', ref: 'speaker_type', remark: 'refPath' })
  speaker: string;
  @prop({ required: false, index: false, zh: '回答人类型', remark: 'Doctor;Nurse' })
  speaker_type: string;
  @prop({ required: false, index: true, zh: '患者', ref: 'Patient' })
  patient: string;
  @prop({ required: false, index: true, zh: '群组', ref: 'Group' })
  group: string;
  @prop({ required: false, index: true, zh: '医生', ref: 'Doctor' })
  doctor: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: false, zh: '是否未读', remark: '1:未读;0-已读', default: '1' })
  not_read: number;
}
