import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
import File from 'free-midway-component/dist/entity/fileType';
@modelOptions({
  schemaOptions: { collection: 'nurse' },
})
export class Nurse extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '头像', remark: '文件类型' })
  icon: File;
  @prop({ required: false, index: false, zh: '手机' })
  mobile: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: false, zh: '医院名称' })
  hos_name: string;
  @prop({ required: false, index: false, zh: '部门名称' })
  dept_name: string;
  @prop({ required: true, index: false, zh: '所属医生', ref: 'Doctor' })
  doctor: string;
  @prop({ required: false, index: false, zh: '职务' })
  title: string;
  @prop({ required: false, index: false, zh: '职称' })
  post: string;
  @prop({ required: false, index: false, zh: '简介' })
  content: string;
  @prop({ required: false, index: false, zh: '微信openid', remark: '小程序的' })
  openid: string;
  @prop({
    required: false,
    index: true,
    zh: '账号',
    remark: '默认为手机号.如果填写,则按填写的来',
  })
  account: string;
}
