import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import File from 'free-midway-component/dist/entity/fileType';
@modelOptions({
  schemaOptions: { collection: 'patient' },
})
export class Patient extends BaseModel {
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: false, zh: '头像', remark: 'FIle类型' })
  icon: File;
  @prop({ required: false, index: false, zh: '就诊编号/卡号' })
  card_no: string;
  @prop({ required: false, index: false, zh: '性别' })
  gender: string;
  @prop({ required: false, index: false, zh: '年龄' })
  age: number;
  @prop({ required: false, index: false, zh: '住址' })
  address: string;
  @prop({ required: false, index: false, zh: '手机' })
  mobile: string;
  @prop({ required: false, index: false, zh: '紧急联系人' })
  urgent_name: string;
  @prop({ required: false, index: false, zh: '紧急联系人手机' })
  urgent_mobile: string;
  @prop({ required: false, index: false, zh: '病例' })
  emrs: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '微信openid',
    remark: '微信小程序的',
  })
  openid: string;
}
