import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_admin {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '系统使用名' })
  'name': string = undefined;
}

export class QDTO_admin extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_admin {
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '系统使用名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
}

export class CVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_admin extends CDTO_admin {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
