import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_adv {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '图片' })
  'image': Array<any> = undefined;
  @ApiProperty({ description: '跳转位置' })
  'url': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_adv extends SearchBase {
  constructor() {
    const like_prop = ['title'];
    const props = ['title', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_adv extends FVO_adv {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_adv {
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'image': Array<any> = undefined;
  @ApiProperty({ description: '跳转位置' })
  @Rule(RuleType['string']().empty(''))
  'url': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_adv extends FVO_adv {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_adv extends CDTO_adv {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_adv extends FVO_adv {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
