import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_chat {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '发送人' })
  'speaker': string = undefined;
  @ApiProperty({ description: '回答人类型' })
  'speaker_type': string = undefined;
  @ApiProperty({ description: '患者' })
  'patient': string = undefined;
  @ApiProperty({ description: '群组' })
  'group': string = undefined;
  @ApiProperty({ description: '医生' })
  'doctor': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '是否未读' })
  'not_read': number = undefined;
}

export class QDTO_chat extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['speaker', 'patient', 'group', 'doctor'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '发送人' })
  'speaker': string = undefined;
  @ApiProperty({ description: '患者' })
  'patient': string = undefined;
  @ApiProperty({ description: '群组' })
  'group': string = undefined;
  @ApiProperty({ description: '医生' })
  'doctor': string = undefined;
}

export class QVO_chat extends FVO_chat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_chat {
  @ApiProperty({ description: '发送人' })
  @Rule(RuleType['string']().empty(''))
  'speaker': string = undefined;
  @ApiProperty({ description: '回答人类型' })
  @Rule(RuleType['string']().empty(''))
  'speaker_type': string = undefined;
  @ApiProperty({ description: '患者' })
  @Rule(RuleType['string']().empty(''))
  'patient': string = undefined;
  @ApiProperty({ description: '群组' })
  @Rule(RuleType['string']().empty(''))
  'group': string = undefined;
  @ApiProperty({ description: '医生' })
  @Rule(RuleType['string']().empty(''))
  'doctor': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '是否未读' })
  @Rule(RuleType['number']().empty(''))
  'not_read': number = undefined;
}

export class CVO_chat extends FVO_chat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_chat extends CDTO_chat {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_chat extends FVO_chat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
