import { ApiProperty } from '@midwayjs/swagger';
import { Rule, RuleType } from '@midwayjs/validate';
import { get } from 'lodash';
export enum LoginType {
  Doctor = 'Doctor',
  Nurse = 'Nurse',
  Patient = 'Patient',
  Admin = 'Admin',
}

export class LoginDTO {
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().required())
  account: string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().required())
  password: string = undefined;
}

export class UPwdDTO {
  @ApiProperty({ description: '用户数据id' })
  @Rule(RuleType['string']().required())
  _id: string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().required())
  password: string = undefined;
}

export class LoginVO {
  constructor(data: object) {
    this._id = get(data, '_id');
    this.name = get(data, 'name');
    this.openid = get(data, 'openid');
    this.role = get(data, 'role');
    this.doctor = get(data, 'doctor');
  }
  _id: string;
  name: string;
  openid: string;
  role: string;
  doctor: string;
}
