import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_patient {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '就诊编号/卡号' })
  'card_no': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': number = undefined;
  @ApiProperty({ description: '住址' })
  'address': string = undefined;
  @ApiProperty({ description: '手机' })
  'mobile': string = undefined;
  @ApiProperty({ description: '紧急联系人' })
  'urgent_name': string = undefined;
  @ApiProperty({ description: '紧急联系人手机' })
  'urgent_mobile': string = undefined;
  @ApiProperty({ description: '病例' })
  'emrs': Array<any> = undefined;
  @ApiProperty({ description: '微信openid' })
  'openid': string = undefined;
}

export class QDTO_patient extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['name', 'openid', 'card_no', 'gender', 'age', 'address', 'mobile', 'urgent_name', 'urgent_mobile'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '微信openid' })
  'openid': string = undefined;
  @ApiProperty({ description: '就诊编号/卡号' })
  'card_no': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': number = undefined;
  @ApiProperty({ description: '住址' })
  'address': string = undefined;
  @ApiProperty({ description: '手机' })
  'mobile': string = undefined;
  @ApiProperty({ description: '紧急联系人' })
  'urgent_name': string = undefined;
  @ApiProperty({ description: '紧急联系人手机' })
  'urgent_mobile': string = undefined;
}

export class QVO_patient extends FVO_patient {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_patient {
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '就诊编号/卡号' })
  @Rule(RuleType['string']().empty(''))
  'card_no': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().empty(''))
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  @Rule(RuleType['number']().empty(''))
  'age': number = undefined;
  @ApiProperty({ description: '住址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '手机' })
  @Rule(RuleType['string']().empty(''))
  'mobile': string = undefined;
  @ApiProperty({ description: '紧急联系人' })
  @Rule(RuleType['string']().empty(''))
  'urgent_name': string = undefined;
  @ApiProperty({ description: '紧急联系人手机' })
  @Rule(RuleType['string']().empty(''))
  'urgent_mobile': string = undefined;
  @ApiProperty({ description: '病例' })
  @Rule(RuleType['array']().empty(''))
  'emrs': Array<any> = undefined;
  @ApiProperty({ description: '微信openid' })
  @Rule(RuleType['string']().empty(''))
  'openid': string = undefined;
}

export class CVO_patient extends FVO_patient {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_patient extends CDTO_patient {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_patient extends FVO_patient {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
