import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_role {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '角色名称' })
  'name': string = undefined;
  @ApiProperty({ description: '角色编码' })
  'code': string = undefined;
  @ApiProperty({ description: '菜单' })
  'menu': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_role extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'code', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '角色名称' })
  'name': string = undefined;
  @ApiProperty({ description: '角色编码' })
  'code': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_role extends FVO_role {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_role {
  @ApiProperty({ description: '角色名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '角色编码' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '菜单' })
  @Rule(RuleType['array']().empty(''))
  'menu': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_role extends FVO_role {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_role extends CDTO_role {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_role extends FVO_role {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
